assert( Necronomicon, "Necronomicon not found!")

----------------------------------
--        Are you local?        --
----------------------------------

local L = AceLibrary("AceLocale-2.2"):new("Necronomicon")

local firestoneid = {
	[1254] = true,
	[13699] = true,
	[13700] = true,
	[13701] = true,
	[22128] = true,
}

local firestoneicon = "Interface\\Icons\\INV_Misc_Gem_Bloodstone_02"

----------------------------------
--      Module Declaration      --
----------------------------------

NecronomiconFirestone = Necronomicon:NewModule("Firestone")

NecronomiconFirestone.revision = tonumber(string.sub("$Revision: 26866 $", 12, -3))

NecronomiconFirestone.defaults = {
	posx = 296,
	posy = 232,
}

----------------------------------
--     Module Intialization     --
----------------------------------

function NecronomiconFirestone:OnRegister()
	self:RegisterSpell("Create Firestone")
	for k, v in pairs( firestoneid ) do
		self:RegisterItem( k ) 
	end
end

function NecronomiconFirestone:OnEnable()
	self:SetupButton()
	self:RegisterEvent("Necronomicon_SpellsUpdated")
	self:RegisterEvent("Necronomicon_BagUpdate")
	self:Necronomicon_SpellsUpdated()
end

----------------------------------
--        Event Handlers        --
----------------------------------

function NecronomiconFirestone:Necronomicon_SpellsUpdated()
	local spell = self:HasSpell("Create Firestone")
	if spell then
		self.button:SetAttribute("type1", "spell")
		self.button:SetAttribute("spell1", ( GetSpellName( spell.id, BOOKTYPE_SPELL) ) )
		self.button.background:SetDesaturated(true)
		self.button.highlight:Hide()
		self.button:Show()

		self:Necronomicon_BagUpdate()
	else
		self.button:SetAttribute("type1", "")
		self.button:SetAttribute("spell1", "" )
		self.button:Hide()	
	end

end

function NecronomiconFirestone:Necronomicon_BagUpdate()
	local item, name
	for k, v in pairs( firestoneid ) do
		item = self:GetItem(k)
		if item then
			self.button:SetAttribute("type1", "item")
			self.button.background:SetDesaturated(false)
			if item.equipped then
				name = (GetItemInfo(GetInventoryItemLink("player",GetInventorySlotInfo("RangedSlot"))))
				self.button:SetAttribute("item1", name)
				self.button:SetAttribute("slot1", (GetInventorySlotInfo("RangedSlot")))
				self.button:SetAttribute("bag1", "")
				self.button.highlight:Show()
			else
				name = (GetItemInfo(GetContainerItemLink( item.bag, item.slot )))
				self.button:SetAttribute("item1", name)
				self.button:SetAttribute("bag1", item.bag)
				self.button:SetAttribute("slot1", item.slot)
				self.button.highlight:Hide()
			end
			break
		end
	end
	if not item then
		self.button.background:SetDesaturated(true)
		self.button:SetAttribute("type1", "spell")
		self.button.highlight:Hide()
	end
end

----------------------------------
--         GUI Functions        --
----------------------------------

function NecronomiconFirestone:SetupButton()
	self:CreateButton()

	self.button.background:SetTexture( firestoneicon )
end
