assert( Necronomicon, "Necronomicon not found!")

----------------------------------
--        Are you local?        --
----------------------------------

local L = AceLibrary("AceLocale-2.2"):new("Necronomicon")

local dreadsteedicon = "Interface\\Icons\\Ability_Mount_Dreadsteed"
local felsteedicon = "Interface\\Icons\\Spell_Nature_Swiftness"
local hasdreadsteed = nil

local flyingmounts = {
	[25470] = true, -- golden gryphon
	[25471] = true, -- ebon gryphon
	[25472] = true, -- snowy gryphon
	[25473] = true, -- swift blue gryphon
	[25527] = true, -- swift red gryphon
	[25528] = true, -- swift green gryphon
	[25529] = true, -- swift purple gryphon
	[25474] = true, -- tawny windrider
	[25475] = true, -- blue windrider
	[25476] = true, -- green windrider
	[25477] = true, -- swift red windrider
	[25531] = true, -- swift green windrider
	[25532] = true, -- swift yellow windrider
	[25533] = true, -- swift purple windrider
}

-- Felsteed
-- Dreadsteed
-- Flying Mount
-- Random Flying / Walking?
-- Leftclick fly, rightclick walk?

----------------------------------
--      Module Declaration      --
----------------------------------

NecronomiconMount = Necronomicon:NewModule("Mount")
NecronomiconMount.name = "Mount"

NecronomiconMount.revision = tonumber(string.sub("$Revision: 27632 $", 12, -3))

NecronomiconMount.defaults = {
	posx = 264,
	posy = 200,
}

----------------------------------
--     Module Intialization     --
----------------------------------

function NecronomiconMount:OnRegister()
	self:RegisterSpell("Summon Felsteed")
	self:RegisterSpell("Summon Dreadsteed")
end

function NecronomiconMount:OnEnable()
	self:SetupButton()
	self:RegisterEvent("Necronomicon_SpellsUpdated")
	self:Necronomicon_SpellsUpdated()
end

----------------------------------
--        Event Handlers        --
----------------------------------

function NecronomiconMount:Necronomicon_SpellsUpdated()
	local dreadsteed = self:HasSpell("Summon Dreadsteed")
	local felsteed = self:HasSpell("Summon Felsteed")

	if dreadsteed then
		self.button:SetAttribute("type1", "spell")
		self.button:SetAttribute("spell1", ( GetSpellName( dreadsteed.id, BOOKTYPE_SPELL) ) )
		self.button.background:SetTexture( dreadsteedicon )
		self.button:Show()
	elseif felsteed then
		self.button:SetAttribute("type1", "spell")
		self.button:SetAttribute("spell1", ( GetSpellName( felsteed.id, BOOKTYPE_SPELL) ) )
		self.button.background:SetTexture( felsteedicon )
		self.button:Show()		
	else
		self.button:SetAttribute("type1", "")
		self.button:SetAttribute("spell1", "" )
		self.button:Hide()		
	end
end

----------------------------------
--         GUI Functions        --
----------------------------------

function NecronomiconMount:SetupButton()
	self:CreateButton()
end
